Skip to content
Snippets Groups Projects
do_tests 6.00 KiB
#!/bin/zsh
# vim: set shiftwidth=4 softtabstop=4:
#
# This script will create a database, install some modules and run tests on it
#
# Arguments:
#
# - db host if any (will use socket if nothing is provided)
# - db user
# - other arguments are forwarded as is to the setup command.
#
# Required:
#
# - access to pg database
#
# Version 2.22

here=$(dirname $0)
project_home=$(cd $here && cd .. && echo $PWD)
dbname=$(basename $project_home)_test
if ! type python3 > /dev/null; then
    python="python2"
else
    python="python3"
fi
# this is the same value as conf/drone/odoo.conf
if [[ -e "${project_home}/conf/drone/odoo.conf" ]];
then
    dbowner=$($python -B -c "from six.moves import configparser ; c = configParser.ConfigParser() ; c.read('${project_home}/conf/drone/odoo.conf') ; print(c.get('options', 'db_user'))")
    unaccent=$($python -B -c "from six.moves import configparser ; c = configparser.ConfigParser() ; c.read('${project_home}/conf/drone/odoo.conf') ; print(c.get('options', 'unaccent') if c.has_option('options', 'unaccent') else False)")
# this is the same value as conf/dev/odoo.conf
elif [[ -e "${project_home}/conf/dev/odoo.conf" ]];
then
    dbowner=$($python -B -c "from six.moves import configparser ; c = configParser.ConfigParser() ; c.read('${project_home}/conf/dev/odoo.conf') ; print(c.get('options', 'db_user'))")
    unaccent=$($python -B -c "from six.moves import configparser ; c = configparser.ConfigParser() ; c.read('${project_home}/conf/dev/odoo.conf') ; print(c.get('options', 'unaccent') if c.has_option('options', 'unaccent') else False)")
else
    dbowner=odoo
    unaccent=False
fi
modules_to_install=$($python -B -c "from six.moves import configparser ; c = configparser.ConfigParser() ; c.read('${project_home}/setup.cfg') ; print(','.join(c.get('odoo_scripts', 'module_list').split()))")
fail_on_errors=$($python -B -c "from six.moves import configparser ; c = configparser.ConfigParser() ; c.read('${project_home}/setup.cfg') ; print(c.get('odoo_scripts', 'fail_on_errors') if c.has_option('odoo_scripts', 'fail_on_errors') else True)")

# color stuff
autoload colors
if [[ "$terminfo[colors]" -gt 7 ]];
then
    echo "[DEBUG] colors"
    colors
fi
for COLOR in RED GREEN YELLOW BLUE MAGENTA CYAN BLACK WHITE; do
    eval $COLOR='$fg_no_bold[${(L)COLOR}]'
    eval BOLD_$COLOR='$fg_bold[${(L)COLOR}]'
done
eval RESET='$reset_color'

# argument handling
if [[ $# -gt 0 ]];
then
    echo "[${YELLOW}INFO${RESET}] Using database host $1"
    PG_HOST=-h$1
    ODOO_HOST=--db_host=$1
    shift
    if [[ $# -gt 0 ]];
    then
	echo "[${YELLOW}INFO${RESET}] Using database user $1"
	PG_USER=-U$1
	ODOO_USER=--db_user=$1
	dbowner=$1
	shift
    else
	PG_USER=""
	ODOO_USER=""
    fi
else
    PG_HOST=""
    ODOO_HOST=""
    PG_USER=""
    ODOO_USER=""
fi
# This should be a parameter if it was simple to parse
INSTALL_ARGUMENTS="--log-level=${INSTALL_LOG_LEVEL:-warn}"
if [[ -n "$ODOO_WITHOUT_DEMO" ]];
then
    INSTALL_ARGUMENTS="$INSTALL_ARGUMENTS --without-demo=$ODOO_WITHOUT_DEMO"
fi

if [[ -z "$ODOO_NO_DROP" ]];
then
    echo "[${YELLOW}INFO${RESET}] Drop any existing database '$dbname'"
    dropdb $PG_HOST $PG_USER --if-exists $dbname --no-password
    echo "[${YELLOW}INFO${RESET}] Create database '$dbname' with owner $dbowner"
    createdb $PG_HOST $PG_USER -O $dbowner $dbname --no-password || { echo ${RED}FATAL${RESET} - Cannot create test database ; exit 1; }
fi
if [[ "$unaccent" == "True" ]];
then
    psql $PG_HOST $PG_USER $dbname -c "CREATE EXTENSION unaccent;"
fi
echo "[${YELLOW}INFO${RESET}] Modules to install: $modules_to_install"
echo "[${YELLOW}INFO${RESET}] Install those modules"
logfile=$(tempfile --suffix=.log)
function clean_logfile() {
    rm $logfile
}
trap clean_logfile INT TERM
$here/start $INSTALL_ARGUMENTS -i $modules_to_install -d $dbname --max-cron-threads=0 --stop-after-init $* $ODOO_HOST $ODOO_USER 2>&1 | tee $logfile | sed -e 's/\(.*\) \(INFO\) \(.*\)/\o033[2m\1\o033[22m \o033[32m\o033[7m\2\o033[27m \3\o033[39m/' -e 's/\(.*\) \(DEBUG\) \(.*\)/\o033[2m\1\o033[22m \o033[33m\o033[7m\2\o033[27m \2\o033[39m/' -e 's/\(.*\) \(WARNING\) \(.*\)/\o033[2m\1\o033[22m \o033[33m\o033[7m\2\o033[27m \3\o033[39m/' -e 's/\(.*\) \(ERROR\) \(.*\)/\o033[2m\1\o033[22m \o033[31m\o033[7m\2\o033[27m \3\o033[0m/' -e 's/ FAILED/ \o033[41m\o033[97m\o033[1mFAILED\o033[0m/' -e 's/ FAIL\(.*\)/ \o033[41m\o033[97m\o033[1mFAIL\o033[49m\o033[31m\1\o033[0m/' -e 's/\(.*\) \(CRITICAL\) \(.*\)/\o033[2m\1\o033[22m \o033[33m\o033[7m\2\o033[27m \3\o033[39m/' -e 's/\(.*\) \(TEST\) \(.*\) \(ERROR\)\(.*\)/\o033[2m\1\o033[22m \o033[34m\o033[7m\2\o033[27m \3\o033[0m \o033[41m\o033[97m\o033[1m\4\o033[49m\o033[31m\5\o033[0m/' -e 's/\(.*\) \(TEST\) \(.*\) \(OK\)/\o033[2m\1\o033[22m \o033[34m\o033[7m\2\o033[27m \3\o033[0m \o033[32m\o033[7m\4\o033[27m\o033[39m/' -e 's/\(.*\) \(TEST\) \(.*\)/\o033[2m\1\o033[22m \o033[34m\o033[7m\2\o033[27m \3 \o033[0m/'
start_status=$pipestatus[1]
if [[ $start_status -ne 0 ]];
then
    echo "[${RED} KO ${RESET}] Cannot install modules (exit ${start_status})"
    exit $start_status
fi
criticals=$(grep ' CRITICAL' $logfile -c)
errors=$(grep ' ERROR' $logfile -c)
warnings=$(grep ' WARNING' $logfile -c)
if [[ $criticals -gt 0 ]];
then
    echo "[${RED} KO ${RESET}] Cannot install modules ($criticals CRITICAL messages found)"
    exit 2
fi

if [[ $errors -gt 0 ]];
then
    if [[ "$fail_on_errors" == "False" ]];
    then
        echo "[${MAGENTA}WARN${RESET}] Install modules with $errors ERROR messages"
    else
        echo "[${RED} KO ${RESET}] Cannot install modules ($errors ERROR messages found)"
        exit 1
    fi
else
    if [[ $warnings -gt 0 ]];
    then
        if [[ "${FAIL_ON_WARNING:-False}" == "False" ]];
        then
            echo "[${MAGENTA}WARN${RESET}] Modules installed ($warnings WARNING messages)"
        else
            echo "[${RED} KO ${RESET}] Cannot install modules ($warnings WARNING messages found)"
            exit 1
        fi
    else
        echo "[${GREEN} OK ${RESET}] Modules installed"
    fi
fi
echo "[${YELLOW}INFO${RESET}] Run tests on $dbname"
$here/run_tests $dbname $ODOO_HOST $ODOO_USER $*